searchNodes=[{"doc":"An elixir wrapper for erlang's :queue , with a constant-time size/1 and a maximum capacity. When items pushed on to the LimitedQueue put it over its maximum capacity, it will drop events according to its drop_strategy/0 .","ref":"LimitedQueue.html","title":"LimitedQueue","type":"module"},{"doc":"Push multiple values to the back of the LimitedQueue . Returns the number of values that were dropped if the LimitedQueue reaches its capacity.","ref":"LimitedQueue.html#append/2","title":"LimitedQueue.append/2","type":"function"},{"doc":"The maximum capacity of the LimitedQueue .","ref":"LimitedQueue.html#capacity/1","title":"LimitedQueue.capacity/1","type":"function"},{"doc":"Filters the queue, i.e. returns only those elements for which fun returns a truthy value.","ref":"LimitedQueue.html#filter/2","title":"LimitedQueue.filter/2","type":"function"},{"doc":"Create a new LimitedQueue with the given maximum capacity. The drop_strategy determines how the queue handles dropping events when overloaded. See drop_strategy/0 for more information.","ref":"LimitedQueue.html#new/2","title":"LimitedQueue.new/2","type":"function"},{"doc":"Remove and return a value from the front of the LimitedQueue . If the LimitedQueue is empty, {:error, :empty} will be returned.","ref":"LimitedQueue.html#pop/1","title":"LimitedQueue.pop/1","type":"function"},{"doc":"Push a value to the back of the LimitedQueue . If the LimitedQueue is full, it will drop an event according to the LimitedQueue 's drop_strategy/0 .","ref":"LimitedQueue.html#push/2","title":"LimitedQueue.push/2","type":"function"},{"doc":"The current number of values stored in the LimitedQueue .","ref":"LimitedQueue.html#size/1","title":"LimitedQueue.size/1","type":"function"},{"doc":"Remove and return multiple values from the front of the LimitedQueue . If the LimitedQueue runs out of values, fewer values than the requested amount will be returned.","ref":"LimitedQueue.html#split/2","title":"LimitedQueue.split/2","type":"function"},{"doc":"The contents of the LimitedQueue as a list.","ref":"LimitedQueue.html#to_list/1","title":"LimitedQueue.to_list/1","type":"function"},{"doc":"The drop_strategy/0 determines how the queue handles dropping events when overloaded. :drop_newest (default) drops incoming events and is the most efficient because it will avoid touching the state when the queue is overloaded. :drop_oldest drops the oldest events from the queue, which may be better behavior where newer events are more relevant to process than older ones.","ref":"LimitedQueue.html#t:drop_strategy/0","title":"LimitedQueue.drop_strategy/0","type":"type"},{"doc":"The opaque internal state of the LimitedQueue .","ref":"LimitedQueue.html#t:t/1","title":"LimitedQueue.t/1","type":"opaque"},{"doc":"limited_queue is a simple Elixir queue, with a constant-time size/1 and a maximum capacity.","ref":"readme.html","title":"limited_queue","type":"extras"},{"doc":"Add it to mix.exs defp deps do [ { :limited_queue , &quot;~&gt; 0.1.0&quot; } ] end Create a new queue with a capacity and drop strategy, then push and pop values from it. queue = LimitedQueue . new ( 2 , :drop_newest ) |&gt; LimitedQueue . push ( &quot;a&quot; ) |&gt; LimitedQueue . push ( &quot;b&quot; ) |&gt; LimitedQueue . push ( &quot;c&quot; ) { :ok , queue , &quot;a&quot; } = LimitedQueue . pop ( queue ) { :ok , queue , &quot;b&quot; } = LimitedQueue . pop ( queue ) { :error , :empty } = LimitedQueue . pop ( queue ) 0 = LimitedQueue . size ( queue ) 2 = LimitedQueue . capacity ( queue ) You can also append/2 multiple values to a queue at once, and get information about how many were dropped. queue = LimitedQueue . new ( 2 , :drop_newest ) { queue , dropped } = LimitedQueue . append ( queue , [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] ) 1 = dropped 2 = LimitedQueue . size ( queue ) { :ok , queue , &quot;a&quot; } = LimitedQueue . pop ( queue ) { :ok , queue , &quot;b&quot; } = LimitedQueue . pop ( queue ) { :error , :empty } = LimitedQueue . pop ( queue ) split/2 allows getting multiple values from the queue at once. queue = LimitedQueue . new ( 10 , :drop_newest ) { queue , 0 } = LimitedQueue . append ( queue , [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ] ) { queue , values } = LimitedQueue . split ( queue , 2 ) [ &quot;a&quot; , &quot;b&quot; ] = values 1 = LimitedQueue . size ( queue )","ref":"readme.html#usage","title":"limited_queue - Usage","type":"extras"},{"doc":"This library contains internal documentation. Documentation is available on HexDocs , or you can generate the documentation from source: $ mix deps.get $ mix docs","ref":"readme.html#documentation","title":"limited_queue - Documentation","type":"extras"},{"doc":"Tests can be run by running mix test in the root directory of the library.","ref":"readme.html#running-the-tests","title":"limited_queue - Running the Tests","type":"extras"},{"doc":"LimitedQueue has similar performance to deque depending on the situation (see Benchmarks). It has a more special-purpose limited interface, it is a single-sided queue, and its internals are built on Erlang's :queue .","ref":"readme.html#compared-to-deque","title":"limited_queue - Compared to deque","type":"extras"},{"doc":"Benchmarks can be run by running mix run bench/&lt;benchmark file&gt;.exs in the root directory of the library.","ref":"readme.html#performance-and-benchmarking","title":"limited_queue - Performance and Benchmarking","type":"extras"},{"doc":"LimitedQueue is released under the MIT License . Check LICENSE file for more information.","ref":"readme.html#license","title":"limited_queue - License","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Discord Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]